## ros-noetic-foxglove-bridge 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
  set(CMAKE_POLICY_DEFAULT_CMP0048 NEW)
endif()
if(POLICY CMP0024)
  cmake_policy(SET CMP0024 NEW)
  set(CMAKE_POLICY_DEFAULT_CMP0024 NEW)
endif()

project(foxglove_bridge LANGUAGES CXX VERSION 0.4.1)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(ENABLE_ASAN "Enable Address Sanitizer" OFF)

find_package(nlohmann_json QUIET)
find_package(OpenSSL REQUIRED)
find_package(Threads REQUIRED)
find_package(websocketpp REQUIRED)
find_package(ZLIB REQUIRED)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(OPTIMIZATION_FLAGS "-DDEBUG")
  if(NOT MSVC)
    set(OPTIMIZATION_FLAGS "${OPTIMIZATION_FLAGS} -O0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fno-omit-frame-pointer")
  endif()
  message("-- Configuring debug build")
else()
  set(OPTIMIZATION_FLAGS "-DNDEBUG -O2")
  message("-- Configuring release build")
endif()

if(MSVC)
  set(DESIRED_WARNINGS "-WX")
else()
  set(DESIRED_WARNINGS "-Wall -Wextra -Wconversion -Wunreachable-code -Wuninitialized -pedantic-errors -Wold-style-cast -Wno-error=unused-variable -Wfloat-equal")
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(DESIRED_WARNINGS "${DESIRED_WARNINGS} -Wmost")
  endif()
  set(DESIRED_WARNINGS "${DESIRED_WARNINGS} -Werror")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OPTIMIZATION_FLAGS} ${DESIRED_WARNINGS}")

IF(NOT WIN32 AND ENABLE_ASAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
  set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
endif()

# Detect big-endian architectures
include(TestBigEndian)
TEST_BIG_ENDIAN(ENDIAN)
if (ENDIAN)
  add_compile_definitions(ARCH_IS_BIG_ENDIAN=1)
endif()

# Build the foxglove_bridge_base library
add_library(foxglove_bridge_base SHARED
  foxglove_bridge_base/src/foxglove_bridge.cpp
  foxglove_bridge_base/src/parameter.cpp
  foxglove_bridge_base/src/serialization.cpp
  foxglove_bridge_base/src/server_factory.cpp
  foxglove_bridge_base/src/test/test_client.cpp
)
target_include_directories(foxglove_bridge_base
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/foxglove_bridge_base/include>
    $<INSTALL_INTERFACE:include>
)
target_link_libraries(foxglove_bridge_base
  OpenSSL::Crypto
  OpenSSL::SSL
  ZLIB::ZLIB
  ${CMAKE_THREAD_LIBS_INIT}
)
if(nlohmann_json_FOUND)
  target_link_libraries(foxglove_bridge_base nlohmann_json::nlohmann_json)
else()
  message(STATUS "nlohmann_json not found, will search at compile time")
endif()

message(STATUS "ROS_VERSION: " $ENV{ROS_VERSION})
message(STATUS "ROS_DISTRO: " $ENV{ROS_DISTRO})
message(STATUS "ROS_ROOT: " $ENV{ROS_ROOT})
if("$ENV{ROS_VERSION}" STREQUAL "1")
  # ROS 1
  if(CATKIN_DEVEL_PREFIX OR catkin_FOUND OR CATKIN_BUILD_BINARY_PACKAGE)
    message(STATUS "Building with catkin")
    set(ROS_BUILD_TYPE "catkin")

    find_package(catkin REQUIRED COMPONENTS nodelet ros_babel_fish rosgraph_msgs roslib roscpp)
    find_package(Boost REQUIRED)

    catkin_package(
      INCLUDE_DIRS foxglove_bridge_base/include
      LIBRARIES foxglove_bridge_base foxglove_bridge_nodelet
      CATKIN_DEPENDS nodelet ros_babel_fish rosgraph_msgs roslib roscpp
      DEPENDS Boost
    )

    add_library(foxglove_bridge_nodelet
      ros1_foxglove_bridge/src/ros1_foxglove_bridge_nodelet.cpp
      ros1_foxglove_bridge/src/param_utils.cpp
      ros1_foxglove_bridge/src/service_utils.cpp
    )
    target_include_directories(foxglove_bridge_nodelet
      SYSTEM PRIVATE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/foxglove_bridge_base/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/ros1_foxglove_bridge/include>
        $<INSTALL_INTERFACE:include>
        ${catkin_INCLUDE_DIRS}
    )
    target_link_libraries(foxglove_bridge_nodelet foxglove_bridge_base ${catkin_LIBRARIES})

    add_executable(foxglove_bridge ros1_foxglove_bridge/src/ros1_foxglove_bridge_node.cpp)
    target_include_directories(foxglove_bridge SYSTEM PRIVATE ${catkin_INCLUDE_DIRS})
    target_link_libraries(foxglove_bridge ${catkin_LIBRARIES})
  else()
    message(FATAL_ERROR "Could not find catkin")
  endif()
elseif("$ENV{ROS_VERSION}" STREQUAL "2")
  # ROS 2
  if(DEFINED ENV{AMENT_PREFIX_PATH})
    message(STATUS "Building with ament_cmake")
    set(ROS_BUILD_TYPE "ament_cmake")

    find_package(ament_cmake REQUIRED)
    find_package(rosgraph_msgs REQUIRED)
    find_package(rclcpp REQUIRED)
    find_package(rclcpp_components REQUIRED)

    add_library(foxglove_bridge_component SHARED
      ros2_foxglove_bridge/src/message_definition_cache.cpp
      ros2_foxglove_bridge/src/param_utils.cpp
      ros2_foxglove_bridge/src/ros2_foxglove_bridge.cpp
      ros2_foxglove_bridge/src/parameter_interface.cpp
      ros2_foxglove_bridge/src/generic_client.cpp
    )
    target_include_directories(foxglove_bridge_component
      PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/foxglove_bridge_base/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/ros2_foxglove_bridge/include>
        $<INSTALL_INTERFACE:include>
    )
    ament_target_dependencies(foxglove_bridge_component rclcpp rclcpp_components rosgraph_msgs)
    target_link_libraries(foxglove_bridge_component foxglove_bridge_base)
    rclcpp_components_register_nodes(foxglove_bridge_component "foxglove_bridge::FoxgloveBridge")

    add_executable(foxglove_bridge
      ros2_foxglove_bridge/src/ros2_foxglove_bridge_node.cpp
    )
    target_include_directories(foxglove_bridge SYSTEM PRIVATE ${rclcpp_INCLUDE_DIRS})
    ament_target_dependencies(foxglove_bridge rclcpp rclcpp_components)
  else()
    message(FATAL_ERROR "Could not find ament_cmake")
  endif()
else()
  message(FATAL_ERROR "ROS_VERSION environment variable must be 1 or 2")
endif()

#### TESTS #####################################################################

if(ROS_BUILD_TYPE STREQUAL "catkin")
  if (CATKIN_ENABLE_TESTING)
    message(STATUS "Building tests with catkin")

    find_package(catkin REQUIRED COMPONENTS roscpp std_msgs std_srvs)
    if(NOT "$ENV{ROS_DISTRO}" STREQUAL "melodic")
      find_package(GTest REQUIRED)
    endif()
    find_package(rostest REQUIRED)

    catkin_add_gtest(version_test foxglove_bridge_base/tests/version_test.cpp)
    target_link_libraries(version_test foxglove_bridge_base)

    catkin_add_gtest(serialization_test foxglove_bridge_base/tests/serialization_test.cpp)
    target_link_libraries(serialization_test foxglove_bridge_base)

    add_rostest_gtest(smoke_test ros1_foxglove_bridge/tests/smoke.test ros1_foxglove_bridge/tests/smoke_test.cpp)
    target_include_directories(smoke_test SYSTEM PRIVATE
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/foxglove_bridge_base/include>
      ${catkin_INCLUDE_DIRS}
      $<INSTALL_INTERFACE:include>
    )
    target_link_libraries(smoke_test foxglove_bridge_base ${catkin_LIBRARIES})
  endif()
elseif(ROS_BUILD_TYPE STREQUAL "ament_cmake")
  if(BUILD_TESTING)
    message(STATUS "Building tests with ament_cmake")

    find_package(ament_cmake_gtest REQUIRED)
    find_package(ament_lint_auto REQUIRED)
    ament_lint_auto_find_test_dependencies()

    ament_add_gtest(version_test foxglove_bridge_base/tests/version_test.cpp)
    target_link_libraries(version_test foxglove_bridge_base)

    ament_add_gtest(serialization_test foxglove_bridge_base/tests/serialization_test.cpp)
    target_link_libraries(serialization_test foxglove_bridge_base)

    ament_add_gtest(smoke_test ros2_foxglove_bridge/tests/smoke_test.cpp)
    ament_target_dependencies(smoke_test rclcpp rclcpp_components std_msgs std_srvs)
    target_link_libraries(smoke_test foxglove_bridge_base)
  endif()
endif()

#### INSTALL ###################################################################

if(ROS_BUILD_TYPE STREQUAL "catkin")
    install(TARGETS foxglove_bridge
      RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
    )
    install(TARGETS foxglove_bridge_base foxglove_bridge_nodelet
      ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
      LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
      RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
    )
    install(FILES nodelets.xml
      DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
    )
    install(DIRECTORY ros1_foxglove_bridge/launch/
      DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
    )
elseif(ROS_BUILD_TYPE STREQUAL "ament_cmake")
    install(TARGETS foxglove_bridge
      DESTINATION lib/${PROJECT_NAME}
    )
    install(TARGETS foxglove_bridge_base foxglove_bridge_component
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib
      RUNTIME DESTINATION bin
    )
    install(DIRECTORY ros2_foxglove_bridge/launch/
      DESTINATION share/${PROJECT_NAME}/
    )
    ament_export_libraries(foxglove_bridge_base foxglove_bridge_component)
    ament_package()
endif()

=== Makefile ===
default: ros2

.PHONY: ros1
ros1:
	docker build -t foxglove_bridge_ros1 --pull -f Dockerfile.ros1 .

.PHONY: ros2
ros2:
	docker build -t foxglove_bridge_ros2 --pull -f Dockerfile.ros2 .

.PHONY: melodic
melodic:
	docker build -t foxglove_bridge_melodic --pull -f Dockerfile.ros1 --build-arg ROS_DISTRIBUTION=melodic .

.PHONY: noetic
noetic:
	docker build -t foxglove_bridge_noetic --pull -f Dockerfile.ros1 --build-arg ROS_DISTRIBUTION=noetic .

.PHONY: galactic
galactic:
	docker build -t foxglove_bridge_galactic --pull -f Dockerfile.ros2 --build-arg ROS_DISTRIBUTION=galactic .

.PHONY: humble
humble:
	docker build -t foxglove_bridge_humble --pull -f Dockerfile.ros2 --build-arg ROS_DISTRIBUTION=humble .

.PHONY: rolling
rolling:
	docker build -t foxglove_bridge_rolling --pull -f Dockerfile.ros2 --build-arg ROS_DISTRIBUTION=rolling .

.PHONY: rosdev
rosdev:
	docker build -t foxglove_bridge_rosdev --pull -f .devcontainer/Dockerfile .

clean:
	docker rmi -f foxglove_bridge_ros1
	docker rmi -f foxglove_bridge_ros2
	docker rmi -f foxglove_bridge_melodic
	docker rmi -f foxglove_bridge_noetic
	docker rmi -f foxglove_bridge_galactic
	docker rmi -f foxglove_bridge_humble
	docker rmi -f foxglove_bridge_rolling
	docker rmi -f foxglove_bridge_rosdev

.PHONY: melodic-test
melodic-test: melodic
	docker run -t --rm foxglove_bridge_melodic bash -c "catkin_make run_tests && catkin_test_results"

.PHONY: noetic-test
noetic-test: noetic
	docker run -t --rm foxglove_bridge_noetic bash -c "catkin_make run_tests && catkin_test_results"

.PHONY: galactic-test
galactic-test: galactic
	docker run -t --rm foxglove_bridge_galactic colcon test --event-handlers console_cohesion+ --return-code-on-test-failure

.PHONY: humble-test
humble-test: humble
	docker run -t --rm foxglove_bridge_humble colcon test --event-handlers console_cohesion+ --return-code-on-test-failure

.PHONY: rolling-test
rolling-test: rolling
	docker run -t --rm foxglove_bridge_rolling colcon test --event-handlers console_cohesion+ --return-code-on-test-failure

.PHONY: lint
lint: rosdev
	docker run -t --rm -v $(CURDIR):/src foxglove_bridge_rosdev python3 /src/scripts/format.py /src

=== debian/changelog ===
ros-noetic-foxglove-bridge (0.4.1-1buster) buster; urgency=high

  * Run client handler functions in separate thread (#165 <https://github.com/foxglove/ros-foxglove-bridge/issues/165>)
  * Fix compilation error due to mismatched new-delete (#163 <https://github.com/foxglove/ros-foxglove-bridge/issues/163>)
  * Decouple server implementation (#156 <https://github.com/foxglove/ros-foxglove-bridge/issues/156>)
  * ROS2 parameter fixes (#169 <https://github.com/foxglove/ros-foxglove-bridge/issues/169>)
  * Fix program crash due to unhandled exception when creating publisher with invalid topic name (#168 <https://github.com/foxglove/ros-foxglove-bridge/issues/168>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 17 Feb 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.4.0-1buster) buster; urgency=high

  * Update README with suggestion to build from source, minor fixes
  * Do not build docker images, remove corresponding documentation (#159 <https://github.com/foxglove/ros-foxglove-bridge/issues/159>)
  * Add option to use permessage-deflate compression (#152 <https://github.com/foxglove/ros-foxglove-bridge/issues/152>)
  * Improve launch file documentation, add missing launch file arguments (#158 <https://github.com/foxglove/ros-foxglove-bridge/issues/158>)
  * Allow unsetting (deleting) parameters (#145 <https://github.com/foxglove/ros-foxglove-bridge/issues/145>)
  * Improve mutex usage (#154 <https://github.com/foxglove/ros-foxglove-bridge/issues/154>)
  * Add sessionId to serverInfo (#153 <https://github.com/foxglove/ros-foxglove-bridge/issues/153>)
  * Performance improvements (#151 <https://github.com/foxglove/ros-foxglove-bridge/issues/151>)
  * Add ROS2 support for calling server-advertised services (#142 <https://github.com/foxglove/ros-foxglove-bridge/issues/142>)
  * Add ROS1 support for calling server-advertised services (#136 <https://github.com/foxglove/ros-foxglove-bridge/issues/136>)
  * ROS2 smoke test: Increase default timeout 8->10 seconds (#143 <https://github.com/foxglove/ros-foxglove-bridge/issues/143>)
  * Fix flaky parameter test (noetic) (#141 <https://github.com/foxglove/ros-foxglove-bridge/issues/141>)
  * Always --pull when building docker images in the makefile (#140 <https://github.com/foxglove/ros-foxglove-bridge/issues/140>)
  * Fix failed tests not causing CI to fail (#138 <https://github.com/foxglove/ros-foxglove-bridge/issues/138>)
  * Fix setting int / int[] parameters not working (ROS 1) (#135 <https://github.com/foxglove/ros-foxglove-bridge/issues/135>)
  * Send ROS_DISTRO to clients via metadata field (#134 <https://github.com/foxglove/ros-foxglove-bridge/issues/134>)
  * Communicate supported encodings for client-side publishing (#131 <https://github.com/foxglove/ros-foxglove-bridge/issues/131>)
  * Fix client advertised channels not being updated on unadvertise (#132 <https://github.com/foxglove/ros-foxglove-bridge/issues/132>)
  * Add support for optional request id for setParameter operation (#133 <https://github.com/foxglove/ros-foxglove-bridge/issues/133>)
  * Fix exception when setting parameter to empty array (#130 <https://github.com/foxglove/ros-foxglove-bridge/issues/130>)
  * Fix wrong parameter field names being used (#129 <https://github.com/foxglove/ros-foxglove-bridge/issues/129>)
  * Add parameter support (#112 <https://github.com/foxglove/ros-foxglove-bridge/issues/112>)
  * Add throttled logging when send buffer is full (#128 <https://github.com/foxglove/ros-foxglove-bridge/issues/128>)
  * Contributors: Hans-Joachim Krauch, John Hurliman

 -- John Hurliman <john@foxglove.dev>  Wed, 15 Feb 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.3.0-1buster) buster; urgency=high

  * Add launch files, add install instructions to README (#125 <https://github.com/foxglove/ros-foxglove-bridge/issues/125>)
  * Drop messages when connection send buffer limit has been reached (#126 <https://github.com/foxglove/ros-foxglove-bridge/issues/126>)
  * Remove references to galactic support from README (#117 <https://github.com/foxglove/ros-foxglove-bridge/issues/117>)
  * Add missing build instructions (#123 <https://github.com/foxglove/ros-foxglove-bridge/issues/123>)
  * Use a single reentrant callback group for all subscriptions (#122 <https://github.com/foxglove/ros-foxglove-bridge/issues/122>)
  * Fix clang compilation errors (#119 <https://github.com/foxglove/ros-foxglove-bridge/issues/119>)
  * Publish binary time data when use_sim_time parameter is true (#114 <https://github.com/foxglove/ros-foxglove-bridge/issues/114>)
  * Optimize Dockerfiles (#110 <https://github.com/foxglove/ros-foxglove-bridge/issues/110>)
  * Contributors: Hans-Joachim Krauch, Ruffin

 -- John Hurliman <john@foxglove.dev>  Wed, 04 Jan 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.2.2-1buster) buster; urgency=high

  * Fix messages not being received anymore after unadvertising a client publication (#109 <https://github.com/foxglove/ros-foxglove-bridge/issues/109>)
  * Allow to whitelist topics via a ROS paramater (#108 <https://github.com/foxglove/ros-foxglove-bridge/issues/108>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Mon, 12 Dec 2022 00:00:00 -0000

ros-noetic-foxglove-bridge (0.2.1-1buster) buster; urgency=high

  * Fix compilation on platforms where size_t is defined as unsigned int
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Mon, 05 Dec 2022 00:00:00 -0000

ros-noetic-foxglove-bridge (0.2.0-1buster) buster; urgency=high

  * Add support for client channels (#66 <https://github.com/foxglove/ros-foxglove-bridge/issues/66>)
  * Add smoke tests (#72 <https://github.com/foxglove/ros-foxglove-bridge/issues/72>)
  * Update package maintainers (#70 <https://github.com/foxglove/ros-foxglove-bridge/issues/70>)
  * [ROS2]: Fix messages not being received anymore after unsubscribing a topic (#92 <https://github.com/foxglove/ros-foxglove-bridge/issues/92>)


=== debian/control ===
Source: ros-noetic-foxglove-bridge
Section: misc
Priority: optional
Maintainer: John Hurliman <john@foxglove.dev>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, libgtest-dev <!nocheck>, libssl-dev, libwebsocketpp-dev, nlohmann-json3-dev, ros-noetic-catkin, ros-noetic-nodelet, ros-noetic-ros-babel-fish, ros-noetic-ros-environment, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslib, ros-noetic-rostest <!nocheck>, ros-noetic-rosunit <!nocheck>, ros-noetic-std-msgs <!nocheck>, ros-noetic-std-srvs <!nocheck>, zlib1g-dev
Homepage: https://github.com/foxglove/ros-foxglove-bridge
Standards-Version: 3.9.2

Package: ros-noetic-foxglove-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl, ros-noetic-nodelet, ros-noetic-ros-babel-fish, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslib, zlib1g-dev
Description: ROS Foxglove Bridge

## ros-noetic-foxglove-bridge 0.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,12 +9,20 @@
   set(CMAKE_POLICY_DEFAULT_CMP0024 NEW)
 endif()
 
-project(foxglove_bridge LANGUAGES CXX VERSION 0.4.1)
+project(foxglove_bridge LANGUAGES CXX VERSION 0.7.1)
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-option(ENABLE_ASAN "Enable Address Sanitizer" OFF)
+macro(enable_strict_compiler_warnings target)
+  if (MSVC)
+    target_compile_options(${target} PRIVATE /WX /W4)
+  elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    target_compile_options(${target} PRIVATE -Wall -Wextra -Wpedantic -Werror -Wold-style-cast -Wfloat-equal -Wmost -Wunused-exception-parameter)
+  else()
+    target_compile_options(${target} PRIVATE -Wall -Wextra -Wpedantic -Werror -Wold-style-cast -Wfloat-equal)
+  endif()
+endmacro()
 
 find_package(nlohmann_json QUIET)
 find_package(OpenSSL REQUIRED)
@@ -23,37 +31,18 @@
 find_package(ZLIB REQUIRED)
 
 if(NOT CMAKE_BUILD_TYPE)
-  set(CMAKE_BUILD_TYPE Debug)
-endif()
-
-if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-  set(OPTIMIZATION_FLAGS "-DDEBUG")
-  if(NOT MSVC)
-    set(OPTIMIZATION_FLAGS "${OPTIMIZATION_FLAGS} -O0")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fno-omit-frame-pointer")
-  endif()
-  message("-- Configuring debug build")
+  set(CMAKE_BUILD_TYPE RelWithDebInfo)
+endif()
+
+# Determine wheter to use standalone or boost asio
+option(USE_ASIO_STANDALONE "Build with standalone ASIO" ON)
+if(USE_ASIO_STANDALONE)
+  message(STATUS "Using standalone ASIO")
+  add_definitions(-DASIO_STANDALONE)
 else()
-  set(OPTIMIZATION_FLAGS "-DNDEBUG -O2")
-  message("-- Configuring release build")
-endif()
-
-if(MSVC)
-  set(DESIRED_WARNINGS "-WX")
-else()
-  set(DESIRED_WARNINGS "-Wall -Wextra -Wconversion -Wunreachable-code -Wuninitialized -pedantic-errors -Wold-style-cast -Wno-error=unused-variable -Wfloat-equal")
-  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-    set(DESIRED_WARNINGS "${DESIRED_WARNINGS} -Wmost")
-  endif()
-  set(DESIRED_WARNINGS "${DESIRED_WARNINGS} -Werror")
-endif()
-
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OPTIMIZATION_FLAGS} ${DESIRED_WARNINGS}")
-
-IF(NOT WIN32 AND ENABLE_ASAN)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
-  set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=address")
-endif()
+  message(STATUS "Using Boost ASIO")
+  find_package(Boost REQUIRED)
+endif(USE_ASIO_STANDALONE)
 
 # Detect big-endian architectures
 include(TestBigEndian)
@@ -62,13 +51,30 @@
   add_compile_definitions(ARCH_IS_BIG_ENDIAN=1)
 endif()
 
+# Get git commit hash and replace variables in version.cpp.in
+find_program(GIT_SCM git DOC "Git version control")
+if (GIT_SCM)
+  execute_process(
+    COMMAND ${GIT_SCM} describe --always --dirty --exclude="*"
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+    OUTPUT_VARIABLE FOXGLOVE_BRIDGE_GIT_HASH
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+  )
+endif()
+set(FOXGLOVE_BRIDGE_VERSION "${CMAKE_PROJECT_VERSION}")
+configure_file(foxglove_bridge_base/src/version.cpp.in
+               foxglove_bridge_base/src/version.cpp @ONLY)
+
 # Build the foxglove_bridge_base library
 add_library(foxglove_bridge_base SHARED
+  foxglove_bridge_base/src/base64.cpp
   foxglove_bridge_base/src/foxglove_bridge.cpp
   foxglove_bridge_base/src/parameter.cpp
   foxglove_bridge_base/src/serialization.cpp
   foxglove_bridge_base/src/server_factory.cpp
   foxglove_bridge_base/src/test/test_client.cpp
+  # Generated:
+  ${CMAKE_CURRENT_BINARY_DIR}/foxglove_bridge_base/src/version.cpp
 )
 target_include_directories(foxglove_bridge_base
   PUBLIC
@@ -86,6 +92,7 @@
 else()
   message(STATUS "nlohmann_json not found, will search at compile time")
 endif()
+enable_strict_compiler_warnings(foxglove_bridge_base)
 
 message(STATUS "ROS_VERSION: " $ENV{ROS_VERSION})
 message(STATUS "ROS_DISTRO: " $ENV{ROS_DISTRO})
@@ -96,13 +103,13 @@
     message(STATUS "Building with catkin")
     set(ROS_BUILD_TYPE "catkin")
 
-    find_package(catkin REQUIRED COMPONENTS nodelet ros_babel_fish rosgraph_msgs roslib roscpp)
+    find_package(catkin REQUIRED COMPONENTS nodelet resource_retriever ros_babel_fish rosgraph_msgs roslib roscpp)
     find_package(Boost REQUIRED)
 
     catkin_package(
       INCLUDE_DIRS foxglove_bridge_base/include
       LIBRARIES foxglove_bridge_base foxglove_bridge_nodelet
-      CATKIN_DEPENDS nodelet ros_babel_fish rosgraph_msgs roslib roscpp
+      CATKIN_DEPENDS nodelet resource_retriever ros_babel_fish rosgraph_msgs roslib roscpp
       DEPENDS Boost
     )
 
@@ -119,10 +126,12 @@
         ${catkin_INCLUDE_DIRS}
     )
     target_link_libraries(foxglove_bridge_nodelet foxglove_bridge_base ${catkin_LIBRARIES})
+    enable_strict_compiler_warnings(foxglove_bridge_nodelet)
 
     add_executable(foxglove_bridge ros1_foxglove_bridge/src/ros1_foxglove_bridge_node.cpp)
     target_include_directories(foxglove_bridge SYSTEM PRIVATE ${catkin_INCLUDE_DIRS})
     target_link_libraries(foxglove_bridge ${catkin_LIBRARIES})
+    enable_strict_compiler_warnings(foxglove_bridge)
   else()
     message(FATAL_ERROR "Could not find catkin")
   endif()
@@ -136,6 +145,7 @@
     find_package(rosgraph_msgs REQUIRED)
     find_package(rclcpp REQUIRED)
     find_package(rclcpp_components REQUIRED)
+    find_package(resource_retriever REQUIRED)
 
     add_library(foxglove_bridge_component SHARED
       ros2_foxglove_bridge/src/message_definition_cache.cpp
@@ -150,15 +160,16 @@
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/ros2_foxglove_bridge/include>
         $<INSTALL_INTERFACE:include>
     )
-    ament_target_dependencies(foxglove_bridge_component rclcpp rclcpp_components rosgraph_msgs)
+    ament_target_dependencies(foxglove_bridge_component rclcpp rclcpp_components resource_retriever rosgraph_msgs)
     target_link_libraries(foxglove_bridge_component foxglove_bridge_base)
     rclcpp_components_register_nodes(foxglove_bridge_component "foxglove_bridge::FoxgloveBridge")
-
+    enable_strict_compiler_warnings(foxglove_bridge_component)
     add_executable(foxglove_bridge
       ros2_foxglove_bridge/src/ros2_foxglove_bridge_node.cpp
     )
     target_include_directories(foxglove_bridge SYSTEM PRIVATE ${rclcpp_INCLUDE_DIRS})
     ament_target_dependencies(foxglove_bridge rclcpp rclcpp_components)
+    enable_strict_compiler_warnings(foxglove_bridge)
   else()
     message(FATAL_ERROR "Could not find ament_cmake")
   endif()
@@ -177,12 +188,19 @@
       find_package(GTest REQUIRED)
     endif()
     find_package(rostest REQUIRED)
+    find_package(Boost REQUIRED COMPONENTS system)
 
     catkin_add_gtest(version_test foxglove_bridge_base/tests/version_test.cpp)
-    target_link_libraries(version_test foxglove_bridge_base)
+    target_link_libraries(version_test foxglove_bridge_base ${Boost_LIBRARIES})
+    enable_strict_compiler_warnings(version_test)
 
     catkin_add_gtest(serialization_test foxglove_bridge_base/tests/serialization_test.cpp)
-    target_link_libraries(serialization_test foxglove_bridge_base)
+    target_link_libraries(serialization_test foxglove_bridge_base ${Boost_LIBRARIES})
+    enable_strict_compiler_warnings(foxglove_bridge)
+
+    catkin_add_gtest(base64_test foxglove_bridge_base/tests/base64_test.cpp)
+    target_link_libraries(base64_test foxglove_bridge_base ${Boost_LIBRARIES})
+    enable_strict_compiler_warnings(foxglove_bridge)
 
     add_rostest_gtest(smoke_test ros1_foxglove_bridge/tests/smoke.test ros1_foxglove_bridge/tests/smoke_test.cpp)
     target_include_directories(smoke_test SYSTEM PRIVATE
@@ -191,6 +209,7 @@
       $<INSTALL_INTERFACE:include>
     )
     target_link_libraries(smoke_test foxglove_bridge_base ${catkin_LIBRARIES})
+    enable_strict_compiler_warnings(smoke_test)
   endif()
 elseif(ROS_BUILD_TYPE STREQUAL "ament_cmake")
   if(BUILD_TESTING)
@@ -202,13 +221,20 @@
 
     ament_add_gtest(version_test foxglove_bridge_base/tests/version_test.cpp)
     target_link_libraries(version_test foxglove_bridge_base)
+    enable_strict_compiler_warnings(version_test)
 
     ament_add_gtest(serialization_test foxglove_bridge_base/tests/serialization_test.cpp)
     target_link_libraries(serialization_test foxglove_bridge_base)
+    enable_strict_compiler_warnings(serialization_test)
+
+    ament_add_gtest(base64_test foxglove_bridge_base/tests/base64_test.cpp)
+    target_link_libraries(base64_test foxglove_bridge_base)
+    enable_strict_compiler_warnings(base64_test)
 
     ament_add_gtest(smoke_test ros2_foxglove_bridge/tests/smoke_test.cpp)
     ament_target_dependencies(smoke_test rclcpp rclcpp_components std_msgs std_srvs)
     target_link_libraries(smoke_test foxglove_bridge_base)
+    enable_strict_compiler_warnings(smoke_test)
   endif()
 endif()
 
@@ -230,6 +256,9 @@
       DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
     )
 elseif(ROS_BUILD_TYPE STREQUAL "ament_cmake")
+    install(FILES ros2_foxglove_bridge/include/foxglove_bridge/ros2_foxglove_bridge.hpp
+      DESTINATION include/${PROJECT_NAME}/
+    )
     install(TARGETS foxglove_bridge
       DESTINATION lib/${PROJECT_NAME}
     )
@@ -238,8 +267,11 @@
       LIBRARY DESTINATION lib
       RUNTIME DESTINATION bin
     )
-    install(DIRECTORY ros2_foxglove_bridge/launch/
+    install(DIRECTORY ros2_foxglove_bridge/launch
       DESTINATION share/${PROJECT_NAME}/
+    )
+    install(FILES ros2_foxglove_bridge/include/foxglove_bridge/utils.hpp
+      DESTINATION include/${PROJECT_NAME}/
     )
     ament_export_libraries(foxglove_bridge_base foxglove_bridge_component)
     ament_package()

=== Makefile ===
ROS1_DISTRIBUTIONS := melodic noetic
ROS2_DISTRIBUTIONS := galactic humble iron rolling

define generate_ros1_targets
.PHONY: $(1)
$(1):
	docker build -t foxglove_bridge_$(1) --pull -f Dockerfile.ros1 --build-arg ROS_DISTRIBUTION=$(1) .

.PHONY: $(1)-test
$(1)-test: $(1)
	docker run -t --rm foxglove_bridge_$(1) bash -c "catkin_make run_tests && catkin_test_results"

.PHONY: $(1)-boost-asio
$(1)-boost-asio:
	docker build -t foxglove_bridge_$(1)_boost_asio --pull -f Dockerfile.ros1 --build-arg ROS_DISTRIBUTION=$(1) --build-arg USE_ASIO_STANDALONE=OFF .

.PHONY: $(1)-test-boost-asio
$(1)-test-boost-asio: $(1)-boost-asio
	docker run -t --rm foxglove_bridge_$(1)_boost_asio bash -c "catkin_make run_tests && catkin_test_results"
endef

define generate_ros2_targets
.PHONY: $(1)
$(1):
	docker build -t foxglove_bridge_$(1) --pull -f Dockerfile.ros2 --build-arg ROS_DISTRIBUTION=$(1) .

.PHONY: $(1)-test
$(1)-test: $(1)
	docker run -t --rm foxglove_bridge_$(1) colcon test --event-handlers console_cohesion+ --return-code-on-test-failure

.PHONY: $(1)-boost-asio
$(1)-boost-asio:
	docker build -t foxglove_bridge_$(1)-boost-asio --pull -f Dockerfile.ros2 --build-arg ROS_DISTRIBUTION=$(1) --build-arg USE_ASIO_STANDALONE=OFF .

.PHONY: $(1)-test-boost-asio
$(1)-test-boost-asio: $(1)-boost-asio
	docker run -t --rm foxglove_bridge_$(1)-boost-asio colcon test --event-handlers console_cohesion+ --return-code-on-test-failure
endef

$(foreach distribution,$(ROS1_DISTRIBUTIONS),$(eval $(call generate_ros1_targets,$(strip $(distribution)))))
$(foreach distribution,$(ROS2_DISTRIBUTIONS),$(eval $(call generate_ros2_targets,$(strip $(distribution)))))


default: ros2

.PHONY: ros1
ros1:
	docker build -t foxglove_bridge_ros1 --pull -f Dockerfile.ros1 .

.PHONY: ros2
ros2:
	docker build -t foxglove_bridge_ros2 --pull -f Dockerfile.ros2 .

.PHONY: rosdev
rosdev:
	docker build -t foxglove_bridge_rosdev --pull -f .devcontainer/Dockerfile .

clean:
	docker rmi $(docker images --filter=reference="foxglove_bridge_*" -q)

.PHONY: lint
lint: rosdev
	docker run -t --rm -v $(CURDIR):/src foxglove_bridge_rosdev python3 /src/scripts/format.py /src

=== debian/changelog ===
ros-noetic-foxglove-bridge (0.7.1-1focal) focal; urgency=high

  * Communicate double / double array parameters with type info, explicitly cast when set from integer (#256 <https://github.com/foxglove/ros-foxglove-bridge/issues/256>)
  * Make ROS 2 smoke tests less flaky (#260 <https://github.com/foxglove/ros-foxglove-bridge/issues/260>)
  * Add debug config for ros2 smoke test (#257 <https://github.com/foxglove/ros-foxglove-bridge/issues/257>)
  * Handle client disconnection in message handler thread (#259 <https://github.com/foxglove/ros-foxglove-bridge/issues/259>)
  * Reduce smoke test flakiness (#258 <https://github.com/foxglove/ros-foxglove-bridge/issues/258>)
  * Server code improvements (#250 <https://github.com/foxglove/ros-foxglove-bridge/issues/250>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Mon, 21 Aug 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.0-1focal) focal; urgency=high

  * Fix ROS2 launch file install rule not installing launch subfolder (#243 <https://github.com/foxglove/ros-foxglove-bridge/issues/243>)
  * Support building with boost asio (#247 <https://github.com/foxglove/ros-foxglove-bridge/issues/247>)
  * Avoid usage of tmpnam() for creating random filename (#246 <https://github.com/foxglove/ros-foxglove-bridge/issues/246>)
  * Implement ws-protocol's fetchAsset specification (#232 <https://github.com/foxglove/ros-foxglove-bridge/issues/232>)
  * Use --include-eol-distros for rosdep to fix melodic builds (#244 <https://github.com/foxglove/ros-foxglove-bridge/issues/244>)
  * Reduce logging severity for parameter retrieval logs (#240 <https://github.com/foxglove/ros-foxglove-bridge/issues/240>)
  * Contributors: Hans-Joachim Krauch, Micah Guttman

 -- John Hurliman <john@foxglove.dev>  Wed, 12 Jul 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.6.4-1focal) focal; urgency=high

  * Assume publisher qos depth of 1 if the middleware reports the qos history as unknown (#239 <https://github.com/foxglove/ros-foxglove-bridge/issues/239>)
  * devcontainer: Use --include-eol-distros for rosdep update (#237 <https://github.com/foxglove/ros-foxglove-bridge/issues/237>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Wed, 05 Jul 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.6.3-1focal) focal; urgency=high

  * Add iron build to CI (#234 <https://github.com/foxglove/ros-foxglove-bridge/issues/234>)
  * Fix QoS history being unknown when copied from existing publisher (#233 <https://github.com/foxglove/ros-foxglove-bridge/issues/233>)
  * Extract ROS 2 bridge header (#228 <https://github.com/foxglove/ros-foxglove-bridge/issues/228>)
  * Contributors: Hans-Joachim Krauch, Milan Vukov

 -- John Hurliman <john@foxglove.dev>  Fri, 16 Jun 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.6.2-1focal) focal; urgency=high

  * Fix connection graph updates to due incorrect use of std::set_difference (#226 <https://github.com/foxglove/ros-foxglove-bridge/issues/226>)
  * Contributors: Ivan Nenakhov

 -- John Hurliman <john@foxglove.dev>  Thu, 11 May 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.6.1-1focal) focal; urgency=high

  * Fix warning messages not being logged (#224 <https://github.com/foxglove/ros-foxglove-bridge/issues/224>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 05 May 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.6.0-1focal) focal; urgency=high

  * Add support for nested parameters (ROS1) (#221 <https://github.com/foxglove/ros-foxglove-bridge/issues/221>)
  * Catch exceptions thrown in handler functions, send status to client (#210 <https://github.com/foxglove/ros-foxglove-bridge/issues/210>)
  * Fix unhandled xmlrpc exception (#218 <https://github.com/foxglove/ros-foxglove-bridge/issues/218>)
  * Add support for action topic and services (ROS2) (#214 <https://github.com/foxglove/ros-foxglove-bridge/issues/214>)
  * Add parameter to include hidden topics and services (ROS 2) (#216 <https://github.com/foxglove/ros-foxglove-bridge/issues/216>)
  * Add workaround for publishers not being cleaned up after they got destroyed (#215 <https://github.com/foxglove/ros-foxglove-bridge/issues/215>)
  * Fix error when compiling with C++20 (#212 <https://github.com/foxglove/ros-foxglove-bridge/issues/212>)
  * Devcontainer improvements (#213 <https://github.com/foxglove/ros-foxglove-bridge/issues/213>)
  * Add parameter for minimum subscription QoS depth (#211 <https://github.com/foxglove/ros-foxglove-bridge/issues/211>)
  * Log version and commit hash when node is started (#209 <https://github.com/foxglove/ros-foxglove-bridge/issues/209>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Thu, 04 May 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.5.3-1focal) focal; urgency=high

  * Fix publishers being created with invalid QoS profile (#205 <https://github.com/foxglove/ros-foxglove-bridge/issues/205>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 31 Mar 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.5.2-1focal) focal; urgency=high

  * Notify client when Server's send buffer limit has been reached (#201 <https://github.com/foxglove/ros-foxglove-bridge/issues/201>)
  * Add support for byte array params (#199 <https://github.com/foxglove/ros-foxglove-bridge/issues/199>)
  * Do not allow connection output buffer to exceed configured limit (#196 <https://github.com/foxglove/ros-foxglove-bridge/issues/196>)
  * Fix exception parameter not being used (#194 <https://github.com/foxglove/ros-foxglove-bridge/issues/194>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Wed, 29 Mar 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.5.1-1focal) focal; urgency=high

  * Add more exception handling (#191 <https://github.com/foxglove/ros-foxglove-bridge/issues/191>)


=== debian/control ===
Source: ros-noetic-foxglove-bridge
Section: misc
Priority: optional
Maintainer: John Hurliman <john@foxglove.dev>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, libgtest-dev <!nocheck>, libssl-dev, libwebsocketpp-dev, nlohmann-json3-dev, ros-noetic-catkin, ros-noetic-nodelet, ros-noetic-resource-retriever, ros-noetic-ros-babel-fish, ros-noetic-ros-environment, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslib, ros-noetic-rostest <!nocheck>, ros-noetic-rosunit <!nocheck>, ros-noetic-std-msgs <!nocheck>, ros-noetic-std-srvs <!nocheck>, zlib1g-dev
Homepage: https://github.com/foxglove/ros-foxglove-bridge
Standards-Version: 3.9.2

Package: ros-noetic-foxglove-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openssl, ros-noetic-nodelet, ros-noetic-resource-retriever, ros-noetic-ros-babel-fish, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslib, zlib1g-dev
Description: ROS Foxglove Bridge

## ros-noetic-foxglove-bridge 0.8.4

=== debian/changelog ===
ros-noetic-foxglove-bridge (0.8.4-1focal) focal; urgency=high

  * also advertise channels for ROS1 topics without publishers (#341 <https://github.com/foxglove/ros-foxglove-bridge/issues/341>)
  * Contributors: Hans-Joachim Krauch

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Fri, 21 Feb 2025 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.3-1focal) focal; urgency=high

  * add best_effort_qos_topic_whitelist param (#329 <https://github.com/foxglove/ros-foxglove-bridge/issues/329>)
  * Add missing functional include in message_definition_cache.cpp (#334 <https://github.com/foxglove/ros-foxglove-bridge/issues/334>)
  * Contributors: David Revay, Silvio Traversaro

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Mon, 03 Feb 2025 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.2-1focal) focal; urgency=high

  * Fix "no matching function" error on yocto kirkstone (#331 <https://github.com/foxglove/ros-foxglove-bridge/issues/331>)
  * Contributors: Graham Harison

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Sun, 01 Dec 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.1-1focal) focal; urgency=high

  * Improve Error Reporting and Reduce Log Redundancy (#327 <https://github.com/foxglove/ros-foxglove-bridge/issues/327>)
  * Contributors: Robin Dumas

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Tue, 26 Nov 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.8.0-1focal) focal; urgency=high

  * Fix usage of deprecated AsyncParametersClient constructor (#319 <https://github.com/foxglove/ros-foxglove-bridge/issues/319>)
  * Add ROS2 JSON publishing support (#307 <https://github.com/foxglove/ros-foxglove-bridge/issues/307>)
  * Contributors: Davide Faconti, Hans-Joachim Krauch

 -- Hans-Joachim Krauch <achim@foxglove.dev>  Wed, 31 Jul 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.10-1focal) focal; urgency=high

  * Make ROS1 service type retrieval more robust (#316 <https://github.com/foxglove/ros-foxglove-bridge/issues/316>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 12 Jul 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.9-1focal) focal; urgency=high

  * Fix parsing of IDL message definitions (#313 <https://github.com/foxglove/ros-foxglove-bridge/issues/313>)
  * Support publishing client message as loaned message (#314 <https://github.com/foxglove/ros-foxglove-bridge/issues/314>)
  * fix: remove extra ";" in websocket_server.hpp (#311 <https://github.com/foxglove/ros-foxglove-bridge/issues/311>)
  * Fix rolling smoke tests crashing (#309 <https://github.com/foxglove/ros-foxglove-bridge/issues/309>)
  * Contributors: Andrey Milko, Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Fri, 05 Jul 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.8-1focal) focal; urgency=high

  * Fix srv definition parsing failing due to carriage return (#303 <https://github.com/foxglove/ros-foxglove-bridge/issues/303>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Tue, 11 Jun 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.7-1focal) focal; urgency=high

  * send service call failure operation (#298 <https://github.com/foxglove/ros-foxglove-bridge/issues/298>)
  * Fix service definition parsing on ROS rolling (#293 <https://github.com/foxglove/ros-foxglove-bridge/issues/293>)
  * Update docs to discourage users from using websocket compression (#297 <https://github.com/foxglove/ros-foxglove-bridge/issues/297>)
  * Update README.md to remove '$ ' so that you can copy and run command (#294 <https://github.com/foxglove/ros-foxglove-bridge/issues/294>)
  * Fix typo in ROS2 launch file example (#296 <https://github.com/foxglove/ros-foxglove-bridge/issues/296>)
  * Contributors: Felipe Galindo, Hans-Joachim Krauch, Jacob Bandes-Storch, Roman Shtylman

 -- John Hurliman <john@foxglove.dev>  Tue, 21 May 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.6-1focal) focal; urgency=high

  * Fix rolling builds (#289 <https://github.com/foxglove/ros-foxglove-bridge/issues/289>)
  * Remove dual ROS 1+2 devcontainer, remove ROS Galactic from the support matrix (#285 <https://github.com/foxglove/ros-foxglove-bridge/issues/285>)
  * Contributors: Hans-Joachim Krauch, John Hurliman

 -- John Hurliman <john@foxglove.dev>  Mon, 26 Feb 2024 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.5-1focal) focal; urgency=high

  * Add ROS 2 dependency for ament_index_cpp (#281 <https://github.com/foxglove/ros-foxglove-bridge/issues/281>)
  * Contributors: Chris Lalancette

 -- John Hurliman <john@foxglove.dev>  Fri, 29 Dec 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.4-1focal) focal; urgency=high

  * Solved bug with incompatible QoS policies
  * added explicit call to ParameterValue() to avoid clang error (#277 <https://github.com/foxglove/ros-foxglove-bridge/issues/277>)
  * Add iron release badge to readme (#271 <https://github.com/foxglove/ros-foxglove-bridge/issues/271>)
  * Contributors: Hans-Joachim Krauch, Ted

 -- John Hurliman <john@foxglove.dev>  Thu, 14 Dec 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.3-1focal) focal; urgency=high

  * Fix asset_uri_whitelist regex backtracking issue, add more extensions (#270 <https://github.com/foxglove/ros-foxglove-bridge/issues/270>)
  * [ROS1] Fix callback accessing invalid reference to promise (#268 <https://github.com/foxglove/ros-foxglove-bridge/issues/268>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Wed, 25 Oct 2023 00:00:00 -0000

ros-noetic-foxglove-bridge (0.7.2-1focal) focal; urgency=high

  * Fix invalid pointers not being caught (#265 <https://github.com/foxglove/ros-foxglove-bridge/issues/265>)
  * Make ROS1 service type retrieval more robust (#263 <https://github.com/foxglove/ros-foxglove-bridge/issues/263>)
  * Contributors: Hans-Joachim Krauch

 -- John Hurliman <john@foxglove.dev>  Tue, 12 Sep 2023 00:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ros-noetic-foxglove-bridge
 Section: misc
 Priority: optional
-Maintainer: John Hurliman <john@foxglove.dev>
+Maintainer: Hans-Joachim Krauch <achim@foxglove.dev>
 Build-Depends: debhelper (>= 9.0.0), libasio-dev, libgtest-dev <!nocheck>, libssl-dev, libwebsocketpp-dev, nlohmann-json3-dev, ros-noetic-catkin, ros-noetic-nodelet, ros-noetic-resource-retriever, ros-noetic-ros-babel-fish, ros-noetic-ros-environment, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslib, ros-noetic-rostest <!nocheck>, ros-noetic-rosunit <!nocheck>, ros-noetic-std-msgs <!nocheck>, ros-noetic-std-srvs <!nocheck>, zlib1g-dev
 Homepage: https://github.com/foxglove/ros-foxglove-bridge
 Standards-Version: 3.9.2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-foxglove-bridge//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
